#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
# !+-------------------------------------------------------------------------
#    Name:  dbamon_email_mass.pl
#
# Version:  @(#)$Revision$
#
# Purpose:  
#
#   Specs: 
#
#  Author:  Bill Border
# !*-------------------------------------------------------------------------

$ProgName = "dbamon_email_mass";
$P = $ProgName;

$missingfile = "/tmp/${P}_Missing_Stars.txt";
$missingsql  = "/tmp/${P}_Missing_Stars.sql";
system("rm $missingfile 2>/dev/null"); 
system("rm $missingsql 2>/dev/null"); 

use DBI;
push(@INC,"/opt/apache/cgi-bin/");
require "cgi_handlers.pl";

# General parms required
$debug = 1;

# Read WWW_Check:
chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
if ($font =~ /%/)
{
  $font =~ s/%/ /g;
  $font = "'$font'";
}

$forward_user = "dbacust";
$forward_file = "/home/$forward_user/.forward";
$text_file = "${P}_$$.txt";

$mode = "prod";
#$mode = "test";

chop($host = `hostname`);
chop($fqhost = `nslookup $host | grep Name: | awk '{ print \$2 }'`);

# See if DBAmon is configured to use Oracle
chop($use_oracle  = `grep Use_Oracle:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
if ($use_oracle eq "Y" && $ORACLE_SID ne "" && $ORACLE_HOME ne "")
{
  $ENV{'ORACLE_SID'}  = $ORACLE_SID;
  $ENV{'ORACLE_HOME'} = $ORACLE_HOME;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $ORACLE_SID;
  #$dbms = "oracle";
}
else
{
  displayError("This module requires that the dbamonrc Use_Oracle: parameter be Y");
}

# Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

############################## Subroutines ###################################

sub Include
{
    $file = $_[0];
    open (FILE, "$file") || die ("Can't open input file $file");
    while ($line = <FILE>) {
      chop( $line );
      print $line;
    }
}

#-----------------------------------------------------------------------------
sub displayError 
{
   #local($errorMsg,@error_fields) = @_;

   #print "Content-type: text/html\n\n";
   #print "<head><title> Database Function Error - Output</title></head>";
   #print "<body>";

   print "</table><p>";
   print "<hr><h3> A Database Error Has Occured:</h3>";
   print "<h4>$errorMsg</h4>";
   print "SQL statement: <pre>$statement</pre>";
   print "Error: <pre>$DBI::errstr</pre>";


   Include("/opt/dbamon/htm/inc/foot_small.html");
   print "</body>";
   print "</html>";

   exit(1);
}

#-----------------------------------------------------------------------------
sub error
#-----------------------------------------------------------------------------
{
  local($errorMsg) = @_;
  print "<b><font color=red><pre>
*--------------------------------------------------------------------------------*
Error: $errorMsg
*--------------------------------------------------------------------------------*
</font></b>";

 if ($DBI::errstr)
 {
   print "</table><p>";
   print "<hr><h3> A Database Error Has Occured:</h3>";
   print "<h4>$errorMsg</h4>";
   print "SQL statement: <pre>$statement</pre>";
   print "Error: <pre>$DBI::errstr</pre>";
 }
 exit 1;
}

#-----------------------------------------------------------------------------
sub errorCheck
{
  foreach $item (sort keys %rqpairs)
  {
    #
    # Any variable name that ends with _ must be in the range of 1-5
    #
    #$len     = length($item);
    #$datalen = length($rqpairs{$item});
    #$data    = $rqpairs{$item};
    ## print "item=$item data=$data\n";
  }

  #if (!$found) 
  #{
  #  push (@error_list, "In order to save anything, you must specify at least 1 DBMS \n");
  #}
}

##-----------------------------------------------------------------------------
#sub IntHandler
#{
#   local($Signal) = @_;
#   close(you_fill_in_the_file_descriptor);
#   unlink($you_fill_in_the_tmp_file_name);
#   exit(0);
#}

#-----------------------------------------------------------------------------
sub error_html 
{
   $manyerrors = @error_list;
   #$str= "" ;
   #$str1="";
   #$str4=" <h3>Insufficient Or Missing Information...</h3><hr>";
   #$html_str=$str.$str1.$str2.$str1.$str4;
   #print "$html_str\n";
   print "<h4>Please correct the following:</h4>";
   print "<p>\n";
   print "<ul>\n";
   foreach( @error_list) 
   {
      print "<li> $_\n<br>";
   }
   print "</ul>\n";
   if ($manyerrors > 3) {
      print "$manyerrors errors - Having a bad day, are we?<p>\n";
   }
   else {
      print "$manyerrors correction(s) to make.<p>\n";
   }
   print "<hr>Click <b>BACK</b> and try again.\n";
      
}
#-----------------------------------------------------------------------------
sub getSTARS
#-----------------------------------------------------------------------------
{
  local($this_hostname, $this_domain, $this_title1) = @_;

  $b4stars = time;

  $this_hostname = lc $this_hostname;

  if ($this_title1 eq "MSSQL")
  {
    $this_title1 = "";
  }
  if ($this_title1 ne "")
  {
    $and_stmt = "and app_instance_nm = '$this_title1'";
  }
  else
  {
    $and_stmt = "";
  }

  # Count tasks
  $statement  = "
    SELECT distinct ldap_emailaddress
    FROM 
      staradm.vwactiveserver v, 
      staradm.srvrapp a, 
      staradm.vwcontactgazer c, 
      staradm.srvrapprolecontact r
    WHERE v.server_id = a.server_id
    and a.srvr_app_id = r.srvr_app_id
    and r.ldap_uid = c.ldap_uid
    and app_type_nm = 'Database'
    and host_nm = '$this_hostname' 
    and dns_domain = '$this_domain'
    $and_stmt
  ";

  ##print "$statement\n";

  $foundstars = 0;

  $sth = $dbhStars->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  while (@Data = $sth->fetchrow_array)
  {
    $this_email = $Data[0];

    $foundstars = 1;

    ##print "Found email address: <b>$this_email</b>\n";

    $z = "$this_hostname.$this_domain/$this_title1";
    printf REPORT "Host/Instance: %-40s  Contact: %-30s\n",
      $z,
      $this_email
      ;

    if ($email_list !~ /$this_email/) 
    {
      $email_list .= "${this_email}\n";
      $email_list_count++;
      $counter_stars++;
    }
  }

  if ($foundstars == 0)
  {
    chop($date = `date +%Y/%m/%d-%H:%M:%S`);
    system("echo '$date | $this_hostname - $this_domain - $this_title1' >> $missingfile"); 
    system("echo '$statement' >> $missingsql"); 
    $missingstars++;
    print "-";
  }
  else
  {
    print "+";
  }

  if ($counter > 0 && ($counter / 100) == int($counter / 100))
  {
    print "\n";
  }

  $dbtime_stars += (time - $b4stars);
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  if ($debug) { print "$date ${P} | $msgmsg\n"; }
}

#-----------------------------------------------------------------------------
sub buildForm 
#-----------------------------------------------------------------------------
{
  print "
<FORM method='POST' action='/cgi-bin/dbamon_email_mass.pl?Submit'>
<font size=2>
Select the desired Distribution List(s) and click 
<b><INPUT type=submit value=' Continue '></b>
here or at the bottom of this form. 
</font>
<p>
<HR>\n";

print"
<table border=1 bgcolor=lightblue>
<tr bgcolor=slate>
    <th><h5>Click To Select These Instances
    <th><h5>Distribution
    <th><h5>Instance Count
</tr>";

print "$form_lines\n";

print " </table> ";

  print " <HR>
<center><p><b>
<INPUT type=submit value=' Continue '>
</center></form></form>";
}

#-----------------------------------------------------------------------------
sub connectDB
#-----------------------------------------------------------------------------
{
  # Connect to the Mysql database
  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
         &displayError('Failed_on_DB_connect_in_updateDb');
}

#------------------------------------------------------------------------------
sub connectDB_STARS
#------------------------------------------------------------------------------
{
  ##&msg("Connecting to STAR Oracle DB");
  use DBI;
  $user = "stargazer";
  $passwd = "i0ndrive";
  $data_source = "DBI:Oracle";
  $database = "STAR";

  $dbhStars = DBI->connect("$data_source:$database", $user, $passwd) ||
    &error('Failed_on_DB_connect');
}

#-----------------------------------------------------------------------------
sub selectALLBuild
#-----------------------------------------------------------------------------
{
  
  $statement  = "select 
    count(*) 
  from
    dbamon.email
  where
    dbamonmode like '${mode}%' ";

  ##print "statement=$statement\n";

  $sth = $dbh->prepare($statement) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $selectcount = -1;
  while (@Data = $sth->fetchrow_array)
  {
    $all_count = $Data[0];
  }

  $form_lines .= "
    <tr >
      <td align=center><input type=checkbox name=cb_ALL>
      <td><h5>All Instances
      <td align=right><font size=2>$all_count</font>\n";
}

#-----------------------------------------------------------------------------
sub selectIDBuild
#-----------------------------------------------------------------------------
{
  local($id) = @_;
  
  $statement  = "select 
    ID$id,
    count(*) 
  from
    dbamon.email
  where
    dbamonmode like '${mode}%'
    and ID$id is not null
  group by
    ID$id";

  ##print "statement=$statement\n";

  $sth = $dbh->prepare($statement) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $selectcount = -1;
  while (@Data = $sth->fetchrow_array)
  {
    $this_id  = $Data[0];
    $this_cnt = $Data[1];
    $form_lines .= "
      <tr >
	<td align=center><input type=checkbox name=cb_ID${id}_${this_id}>
	<td><h5>ID${id}: $this_id
	<td align=right><font size=2>$this_cnt</font>\n";
  }
}

#-----------------------------------------------------------------------------
sub selectALL_STARS
#-----------------------------------------------------------------------------
{
  $b4 = time;

  &msg("<b>Selecting instances and STARS data for ALL instances</b>");
  
  $counter = 0;
  $counter_stars = 0;
  undef @instance_list;

  $statement  = "select distinct
    rmt_hostname,
    rmt_domain,
    rmt_title1
  from
    dbamon.email
  where
    dbamonmode like '${mode}%' ";

  ##print "statement=$statement\n";

  $sth = $dbh->prepare($statement) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $selectcount = -1;
  while (@Data = $sth->fetchrow_array)
  {
    $this_host   = $Data[0];
    $this_domain = $Data[1];
    $this_title1 = $Data[2];

    next if $this_host eq "";

    #if ($this_host =~ /^e/)
    #{
    #  print "$this_host $this_domain $this_title1\n";
    #}
    &msg("DEBUG - Found instance $this_host $this_domain $this_title1");

    $all = "$this_host $this_domain $this_title1";
    push (@instance_list, $all);
  }

  $dbtime_dbamon += (time - $b4);

  foreach $this_line (@instance_list)
  {
    @words = split(/ /,$this_line);
    $this_host   = $words[0];
    $this_domain = $words[1];
    $this_title1 = $words[2];

    ##&msg("Selecting STARS data for host=$this_host domain=$this_domain title1=$this_title1");

    &getSTARS($this_host, $this_domain, $this_title1);

    $counter++;
  }
  print "<br>";
  &msg("Selected $counter distinct server entries resulting in $counter_stars new STARS EMail addresses");
}

#-----------------------------------------------------------------------------
sub selectDBMS_STARS
#-----------------------------------------------------------------------------
{
  local($this_dbms) = @_;

  $b4 = time;

  &msg("<b>Selecting instances and STARS data for dbms=$this_dbms</b>");
  
  $counter = 0;
  $counter_stars = 0;
  undef @instance_list;

  $statement  = "select distinct
    rmt_hostname,
    rmt_domain,
    rmt_title1
  from
    dbamon.email
  where
    dbamonmode like '${mode}%'
    and dbms = '$this_dbms' ";

  ##print "statement=$statement\n";

  $sth = $dbh->prepare($statement) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $selectcount = -1;
  while (@Data = $sth->fetchrow_array)
  {
    $this_host   = $Data[0];
    $this_domain = $Data[1];
    $this_title1 = $Data[2];

    next if $this_host eq "";

    $all = "$this_host $this_domain $this_title1";
    push (@instance_list, $all);
  }

  $dbtime_dbamon += (time - $b4);

  foreach(@instance_list)
  {
    @words = split;
    $this_host   = $words[0];
    $this_domain = $words[1];
    $this_title1 = $words[2];

    ##&msg("Selecting STARS data for host=$this_host domain=$this_domain title1=$this_title1");

    &getSTARS($this_host, $this_domain, $this_title1);
    $counter++;

  }
  print "<br>"; 
  &msg("Selected $counter distinct server entries resulting in $counter_stars STARS EMail addresses");
}

#-----------------------------------------------------------------------------
sub selectDBMSANDVER_STARS
#-----------------------------------------------------------------------------
{
  local($this_dbmsandver) = @_;

  $b4 = time;

  &msg("<b>Selecting instances and STARS data for dbmsandver=$this_dbmsandver</b>");
  
  $counter = 0;
  $counter_stars = 0;
  undef @instance_list;

  $statement  = "select distinct
    rmt_hostname,
    rmt_domain,
    rmt_title1
  from
    dbamon.email
  where
    dbamonmode like '${mode}%'
    and dbmsandver = '$this_dbmsandver' ";

  ##print "statement=$statement\n";

  $sth = $dbh->prepare($statement) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $selectcount = -1;
  while (@Data = $sth->fetchrow_array)
  {
    $this_host   = $Data[0];
    $this_domain = $Data[1];
    $this_title1 = $Data[2];

    next if $this_host eq "";

    $all = "$this_host $this_domain $this_title1";
    push (@instance_list, $all);
  }

  $dbtime_dbamon += (time - $b4);

  foreach(@instance_list)
  {
    @words = split;
    $this_host   = $words[0];
    $this_domain = $words[1];
    $this_title1 = $words[2];

    ##&msg("Selecting STARS data for host=$this_host domain=$this_domain title1=$this_title1");

    &getSTARS($this_host, $this_domain, $this_title1);
    $counter++;

  }
  print "<br>"; 
  &msg("Selected $counter distinct server entries resulting in $counter_stars STARS EMail addresses");
}

#-----------------------------------------------------------------------------
sub selectID_STARS
#-----------------------------------------------------------------------------
{
  local($this_id,$this_value) = @_;

  $b4 = time;

  &msg("<b>Selecting instances and STARS data for id=$this_id value=$this_value</b>");
  
  $counter = 0;
  $counter_stars = 0;
  undef @instance_list;

  $statement  = "select distinct
    rmt_hostname,
    rmt_domain,
    rmt_title1
  from
    dbamon.email
  where
    dbamonmode like '${mode}%'
    and $this_id = '$this_value' ";

  ##print "statement=$statement\n";

  $sth = $dbh->prepare($statement) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $selectcount = -1;
  while (@Data = $sth->fetchrow_array)
  {
    $this_host   = $Data[0];
    $this_domain = $Data[1];
    $this_title1 = $Data[2];

    next if $this_host eq "";

    $all = "$this_host $this_domain $this_title1";
    push (@instance_list, $all);
  }

  $dbtime_dbamon += (time - $b4);

  foreach(@instance_list)
  {
    @words = split;
    $this_host   = $words[0];
    $this_domain = $words[1];
    $this_title1 = $words[2];

    ##&msg("Selecting STARS data for host=$this_host domain=$this_domain title1=$this_title1");

    &getSTARS($this_host, $this_domain, $this_title1);
    $counter++;
  }
  print "<br>"; 
  &msg("Selected $counter distinct server entries resulting in $counter_stars STARS EMail addresses");
}

#-----------------------------------------------------------------------------
sub selectDBMSBuild
#-----------------------------------------------------------------------------
{
  
  $statement  = "select 
    dbms,
    count(*) 
  from
    dbamon.email
  where
    dbamonmode like '${mode}%'
    and dbms is not null
  group by
    dbms";

  ##print "statement=$statement\n";

  $sth = $dbh->prepare($statement) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $selectcount = -1;
  while (@Data = $sth->fetchrow_array)
  {
    $this_dbms = $Data[0];
    $this_cnt  = $Data[1];
    $form_lines .= "
      <tr >
	<td align=center><input type=checkbox name=cb_DBMS_${this_dbms}>
	<td><h5>DBMS: $this_dbms
	<td align=right><font size=2>$this_cnt</font>\n";
  }
}

#-----------------------------------------------------------------------------
sub selectDBMSAndVerBuild
#-----------------------------------------------------------------------------
{
  $statement  = "select 
    dbmsandver,
    count(*) 
  from
    dbamon.email
  where
    dbamonmode like '${mode}%'
    and dbmsandver is not null
  group by
    dbmsandver";

  ##print "statement=$statement\n";

  $sth = $dbh->prepare($statement) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $selectcount = -1;
  while (@Data = $sth->fetchrow_array)
  {
    $this_dbms = $Data[0];
    $this_cnt  = $Data[1];

    @words = split('-',$this_dbms);
    ##print "<pre>wl=$words[$#words]</pre>\n";
    if ($words[$#words] ne $words[$#words] + 0 && $words[$#words] !~ /0$/)
    {
      next;
    }

    $form_lines .= "
      <tr>
	<td align=center><input type=checkbox name=cb_DBMSANDVER_${this_dbms}>
	<td><h5>DBMS-Ver: $this_dbms
	<td align=right><font size=2>$this_cnt</font>\n";
  }
}

#-----------------------------------------------------------------------------
sub custom_html 
#-----------------------------------------------------------------------------
{
 print "<h1>Thank you for using this input form.</h1>";
 print "<h2>Your request has been sent.</h2>";
 print "<p><hr>\n";
}

#-----------------------------------------------------------------------------
sub CheckForEvilness
#-----------------------------------------------------------------------------
{
local($woid2check) = @_;
if (($woid2check =~ /\//) ||
    ($woid2check =~ /\;/) ||
    ($woid2check =~ /\</) ||
    ($woid2check =~ /\>/) ||
    ($woid2check =~ /\*/) ||
    ($woid2check =~ /\|/) ||
    ($woid2check =~ /\'/) ||
    ($woid2check =~ /\&/) ||
    ($woid2check =~ /\!/) ||
    ($woid2check =~ /\#/) ||
    ($woid2check =~ /\(/) ||
    ($woid2check =~ /\)/) ||
    ($woid2check =~ /\[/) ||
    ($woid2check =~ /\]/) ||
    ($woid2check =~ /\{/) ||
    ($woid2check =~ /\}/) ||
    ($woid2check =~ /\:/) ||
    ($woid2check =~ /\'/) ||
    ($woid2check =~ /\//) ||
    ($woid2check =~ /\n/) ||
    ($woid2check =~ /\"/))
      {
	print "Content-type: text/html\n\n";
	print "You have entered spurious control characters in a field.\n";
	print "You cannot use any of the following characters:\n";
	print " ;<>*|\'&!#()[]{}:\'/\"";
	print "\n The entry that is suspect is [$woid2check]\n";
	print "Please retry...\n";
	exit;
       }
}


#-----------------------------------------------------------------------------
# Main
#-----------------------------------------------------------------------------


$| = 1;
chop($CurrentDate = `date`);

$report_file = "/tmp/${P}_report.log";
unlink($report_file);
open(REPORT, ">>$report_file" );
print REPORT "=============================================\n$CurrentDate : \n";

#
# Variables
#

$verb = $ARGV[0];

#system("echo '' | mailx -s '$P | $ENV{\"REMOTE_HOST\"} verb=$verb [AUTO]' bill_border\@thecompany.com");

$SaveFile = "/tmp/$P.log";
unlink($SaveFile);
open(LOG, ">>$SaveFile" );
print LOG "$CurrentDate : \n";

#
# Make header
#

print "Content-type: text/html\n\n";
print "<head><title>DBAmon Mass EMail</title></head> \n";
print "<meta http-equiv=\"refresh\"\n";
Include("/opt/dbamon/htm/inc/head_top.html");
print "<tr bgcolor=wheat><td>
 <center><img src='/dbamon/img/mail.gif' width=25> <font face=$font size=5> Mass EMail </font></center>\n";
 
$links_include = `cat /opt/dbamon/lib/trans_links.txt`;
print "
</table>
<table width=750>

 $links_include

</table>
<hr>
";



&get_request;
#
# When this pgm is invoked, it can be 1 of 2 ways:
# 1. With the KEY arg -> display confirm panel with this pgm as SUBMIT
# 2. With no arg (from submit) -> Delete row
#

#
# Connect to DB
#
&connectDB;

$form_lines = "";
$email_list = "";

#
# 1. Display Form with current values
#

#
# Get form data
#

##print "verb=$verb\n";
if ($verb eq "")
{
  print "
  <p><font size=2>This transaction allows you send email to the STARS DB Contacts for the groups 
  of DB instnaces that you select here. After you click 
  <br>CONTINUE, the email address that are
  associated with these instances will be extracted from STARS (this could take a few minutes). 
  <br>These email addresses will then be placed in the UX forward file for UX user=<b>$forward_user</b>.
  Then you will be able to click again to open 
  <br>an Outlook window with the <b>To:</b> line specified
  as <b>$forward_user\@$host</b>. EMail will not be sent until you click SEND from Outlook.
  </font>
  \n";


  # 
  # Select existing data
  #
  &selectALLBuild;
  &selectDBMSBuild;
  &selectDBMSAndVerBuild;
  &selectIDBuild("1");
  &selectIDBuild("2");
  &selectIDBuild("3");
  &selectIDBuild("4");
  &selectIDBuild("5");
  &selectIDBuild("6");
  &selectIDBuild("7");
  &selectIDBuild("8");

  # 
  # Build form
  #
  &buildForm;
}

#
# 2. They clicked SUBMIT (Save Changes)
#

elsif ($verb eq "STARMissing")
{
  &connectDB_STARS;
  &selectALL_STARS;
}

else
{
  #
  # Save rqpairs to an easier name
  #

  print "<pre>";
  &msg("Using forward file for user: <b>$forward_user</b>");

  &connectDB_STARS;

  foreach $item (sort keys %rqpairs)
  {
    #$f{$item} = $rqpairs{$item};
    print LOG "$item = $rqpairs($item}\n";

    @words = split(/_/,$item);
    #$w1 = $words[0];
    $w2 = $words[1];
    $w3 = $words[2];

    ##print "\nDEBUG: $item=$rqpairs{$item} w1=$w1 w2=$w2 w3=$w3\n";

    if ($w2 eq "ALL")
    {
      &selectALL_STARS;
    }

    if ($w2 eq "DBMS")
    {
      &selectDBMS_STARS("$w3");
    }

    if ($w2 eq "DBMSANDVER")
    {
      &selectDBMSANDVER_STARS("$w3");
    }

    if ($w2 =~ /^ID/)
    {
      &selectID_STARS("$w2","$w3");
    }
  }

  $email_list_length = length($email_list);
  &msg("email_list_length=$email_list_length email_list_count=$email_list_count");
  &msg("dbtime_stars=$dbtime_stars dbtime_dbamon=$dbtime_dbamon");

  &msg("Writing to forward file: $forward_file");
  open(FORWARD, ">$forward_file") || &error("Cannot open output $forward_file - $!");
  print FORWARD "$email_list\n" || &error("Cannot write to $forward_file");
  close(FORWARD) || &error("Cannot close $forward_file");

  system("sort $forward_file > /opt/dbamon/htm/tmp/$text_file");

  if ($email_list ne "")
  {
    print " <ul><li><font size=2><a href=\"mailto:$forward_user\@$fqhost\"><b>Click Here To Send Outlook EMail To $email_list_count Addresses</b></a></font>
    </ul> ";
  }

  &msg("EMail Recipients:");
  print "\n<iframe src='/dbamon/tmp/$text_file'></iframe>\n";

  print "\nThere were $missingstars DB instances which did not have valid STARS contacts. List saved as $missingfile.\n";
  print "<hr></pre>\n";
  print "<script language='JavaScript'> function back() { history.go(-2); }</script>\n";
  print "<font size=2><a href='javascript:back()'><b>Click Here</a></b> to return to the DBAmon Console.</font>";
}

#
# Make footer
#

Include("/opt/dbamon/htm/inc/foot_small.html");

#
# Go away
#

close(LOG);
close(REPORT);
exit 0;
