#set P = SingleLine

#shell #processrows
  date +%Y/%m/%d-%H:%M:%S
#endshell
#call $shellrow ( thedate )

#shell #processrows
  echo $THIS_TARGET 
#endshell
#call $shellrow ( thetarget )

#shell #processrows
  echo $DBAMON_PL_FILE 
#endshell
#call $shellrow ( inputfile )

#shell #processrows
  echo $DBAMON_PL_FILE_JPEG
#endshell
#call $shellrow ( jpeg_file )

#shell #processrows
  echo $DBAMON_PL_INSTANCE 
#endshell
#call $shellrow ( dbamon_instance )

#shell #processrows
  echo $DBAMON_PL_METRIC 
#endshell
#call $shellrow ( dbamon_metric )

#proc getdata
  file: d1.data
//  file: z.txt

#proc settings
  numbernotation: us

#proc page
  textsize: 10
//  font: times
//  outfilename: @P.jpeg
  outfilename: d2.png 
//  backgroundcolor: white
  pagesize: 8.5 5.2
  titledetails: align=left  adjust=-0.8,-4.35 size=7
  title: DBAmon / Ploticus - Created=@thedate PL_Program=@P Obs=@NRECORDS

// #proc image
//   file: ./hplogo2.gif
//   location: 0.1 0.8 
//   width: 65
//   height: 55

#proc areadef
  title: DBAmon Historical Metrics - Instance: @dbamon_instance\nMetric: @dbamon_metric \n
  titledetails: align=center size=14 adjust=0,0.2
//  titledetails: align=center size=8 color=black style=B adjust=2,1.25 
//  titledetails: align=bottom size=8 color=black style=B 
  xscaletype: datetime yyyy/mm/dd.hh:mm
  xautorange: datafield=1
  yautorange: datafield=2
  rectangle: 1 1 7 4

  xaxis.stubvert: yes 
  xaxis.stubs: inc 
  xaxis.stubs: datetimematic 
  xaxis.minortics: none 
  xaxis.labeldistance: 1.6
  xaxis.grid: width=0.1  style=1
  xaxis.autodays: no 
  xaxis.autoyears: no 
  xaxis.automonths: no 
  xaxis.labeldetails: size=7 color=green style=B 
  xaxis.stubformat: yyyy/mm/dd

  yaxis.labeldetails: size=8 color=black style=B
  yaxis.labeldistance: 0.7
  yaxis.grid: width=0.1  style=1
  yaxis.stubs: inc
  yaxis.label: Metric: @dbamon_metric 

#proc lineplot
  xfield: 1
  yfield: 2
  legendlabel: Metric\nValue
  linedetails: color=red width=1.0 
  
// compute and render moving average curve using proc curvefit
 #proc curvefit
   xfield: 1
   yfield: 2
   order: 5
   curvetype: movingavg 
   maxinpoints: 10000
   legendlabel: 5 Obs.\nMoving\nAverage
   linedetails: color=green width=1.0 

#proc legend
  location: max+0.7 max-0.5 
  format: down

//  xaxis.stubs: list Jul\nAug\nSep\nOct\nNov\nDec
//  xrange: 2010/01 2010/12
//  xaxis.autoyears: yyyy 
//  xaxis.stubs: inc 1  month
//  xaxis.stubrange: 201007 201012
//  xaxis.stubformat: YYYY/MM
//  xaxis.automonths: mm 
//  font: clb9x15
//  titledetails: align=right  adjust=0.3,-3.15 size=7
//  frame: bevel
//  yaxis.stubs: incremental 500
//  xaxis.label: Date 
//  xaxis.labeldistance: 0.9
//  pointsymbol: shape=pixtriangle  style=filled radius=0.02 color=blue
